package aaa;

import java.awt.Color;
import robocode.*;

/**

 */
public class Sentry_WallKiller_Anti_Clock extends Robot {

    boolean peek; // Don't turn if there's a robot there
    double moveAmount; // How much to move

    /**
     * run: Move around the walls
     */
    public void run() {
	// Set colors
	setColors(Color.white, Color.white, Color.white);

	// Initialize moveAmount to the maximum possible for this battlefield.
	moveAmount = Math.max(getBattleFieldWidth(), getBattleFieldHeight());
	// Initialize peek to false
	peek = false;

	// turnLeft to face a wall.
	// getHeading() % 90 means the remainder of
	// getHeading() divided by 90.
	turnLeft(getHeading() % 90);
	ahead(moveAmount);
	// Have the gun point along the wall
	peek = true;
	turnGunRight(0);
	// Turn Left so we travel anticlockwise around the edge of the arena
	turnLeft(90);
	int numleft;

	while (true) {
	    // Look before we turn when ahead() completes.
	    peek = true;
	    // Move up the wall
	    ahead(moveAmount);

	    // Don't look now
	    peek = false;
	    // Turn Left to move to the next wall
	    turnLeft(90);
	}
    }

    /**
     * onHitRobot: Move away a bit if its another sentry, otherwise fire if he
     * is in front of us and then RAM ! If the robot is behind perform a reverse
     * RAM
     */
    public void onHitRobot(HitRobotEvent e) {
	// If he's in front of us, set back up a bit.
	if (e.getName().startsWith("aaa.Sentry")
		|| e.getName().startsWith("aaa.sentry")) {

	    if (e.getBearing() > -90 && e.getBearing() < 90) {
		back(moveAmount * 0.1);
	    } // else he's in back of us, so set ahead a bit.
	    else {
		ahead(moveAmount);
	    }

	}
	// if the robot is not wallkiller attack
	else {
	    if (e.getBearing() > -90 && e.getBearing() < 90) {
		fire(3);
		ahead(moveAmount);
	    } // else he's in back of us, so set ahead a bit.
	    else {
		back(moveAmount);
	    }
	}
    }

    /**
     * onScannedRobot: Fire!
     */
    public void onScannedRobot(ScannedRobotEvent e) {
	// If the robot is wallkiller clockwise back away
	if (e.getName().startsWith("aaa.Sentry")
		|| e.getName().startsWith("aaa.sentry")) {
	    // Do nothing
	}
	// if the robot is not wallkiller attack
	else {
	    if (e.getEnergy() > 30) {
		fire(3);
		fire(2);

	    } else {
		fire(3);

	    }
	    if (peek) {
		scan();
	    }
	}
    }
}
